# This file is placed in the Public Domain.


"DragonFlyTests"


import os
import sys


sys.path.insert(0, os.getcwd())


import unittest


from dfly.function import edit
from dfly.kernel import Config
from dfly.object import Object, update
from dfly.parse import parse


class Test_Config(unittest.TestCase):

    def test_parse(self):
        p = Config()
        parse(p, "mod=irc")
        self.assertEqual(p.sets.mod, "irc")

    def test_parse2(self):
        p = Config()
        parse(p, "mod=irc,rss")
        self.assertEqual(p.sets.mod, "irc,rss")

    def test_edit(self):
        d = Object()
        update(d, {"mod": "irc,rss"})
        edit(Config, d)
        self.assertEqual(Config.mod, "irc,rss")
